
alusta :-
	mine(seis(ida,ida,ida,ida), seis(laane,laane,laane,laane)).

mine(Seis, Eesmark) :-
	seisujada(Seis, Eesmark, [Seis], Nimistu),
	nl, write('Lahendus on:'),
	nl, naita_lahendus(Nimistu),
	fail.

mine(_,_).

seisujada(Eesmark, Eesmark, Tegemised, Tegemised) :-
	!.

seisujada(Seis, Eesmark, Tegemised, ZZZ) :-
	ylesoit(Seis, Seis1),
	not keelatud(Seis1),
	not is_member(Seis1, Tegemised),
	seisujada(Seis1, Eesmark, [Seis1|Tegemised], ZZZ).

ylesoit(seis(Rand1, Rand1, Kits, Kapsad), seis(Rand2, Rand2, Kits, Kapsad)) :-
	vastaspoolne(Rand1, Rand2).

ylesoit(seis(Rand1, Hunt, Rand1, Kapsad), seis(Rand2, Hunt, Rand2, Kapsad)) :-
	vastaspoolne(Rand1, Rand2).

ylesoit(seis(Rand1, Hunt, Kits, Rand1), seis(Rand2, Hunt, Kits, Rand2)) :-
	vastaspoolne(Rand1, Rand2).

ylesoit(seis(Rand1, Hunt, Kits, Kapsad), seis(Rand2, Hunt, Kits, Kapsad)) :-
	vastaspoolne(Rand1, Rand2).

vastaspoolne(ida, laane).
vastaspoolne(laane, ida).

keelatud(seis(Farmer, Rand, Rand, _)) :-
	vastaspoolne(Farmer, Rand).

keelatud(seis(Farmer, _, Rand, Rand)) :-
	vastaspoolne(Farmer, Rand).

naita_lahendus([T1,T2|T]) :-
	!,
	naita_ylesoit(T2,T1),
	naita_lahendus([T2|T]).
	naita_lahendus(_).

naita_ylesoit(seis(Rand1, Hunt, Kits, Kapsad), seis(Rand2, Hunt, Kits, Kapsad)) :-
	!,
	write('Farmer siirdub je '),
	write(Rand1),
	write('rannalt '),
	write(Rand2),
	write('rannale.'),
	nl.

naita_ylesoit(seis(Rand1, Rand1, Kits, Kapsad), seis(Rand2, Rand2, Kits, Kapsad)) :-
	!,
	write('Farmer saadab hundi je '),
	write(Rand1),
	write('rannalt '),
	write(Rand2),
	write('rannale.'),
	nl.

naita_ylesoit(seis(Rand1, Hunt, Rand1, Kapsad), seis(Rand2, Hunt, Rand2, Kapsad)) :-
	!,
	write('Farmer viib kitse je '),
	write(Rand1),
	write('rannalt '),
	write(Rand2),
	write('rannale.'),
	nl.

naita_ylesoit(seis(Rand1, Hunt, Kits, Rand1),seis(Rand2, Hunt, Kits, Rand2)) :-
	!,
	write('Farmer viib kapsad je '),
	write(Rand1),
	write('rannalt '),
	write(Rand2),
	write('rannale.'),
	nl.

