reaktsioon([pyriit, sysi], raudsulfaat).
reaktsioon([pyriit, sysi], alumiiniumsulfaat).
reaktsioon([meretaimed], sooda).
reaktsioon([rasv, sooda], seep).
reaktsioon([rasv, sooda], glytseriin).
reaktsioon([raudsulfaat], vaavelhape).
reaktsioon([vaavelhape, salpeeter], lammastikhape).
reaktsioon([vaavelhape, lammastikhape], nitroglytseriin).

olemas(pyriit).
olemas(sysi).
olemas(meretaimed).
olemas(rasv).
olemas(salpeeter).

saab_valmistada(Aine):-
	olemas(Aine).

saab_valmistada(Aine):-
	reaktsioon(Ained, Aine),
	saab_koiki(Ained).

saab_koiki([]).

saab_koiki([Esimene|Muud]):-
	saab_valmistada(Esimene),
	saab_koiki(Muud).


mida_vaja(Aine, Aine) :-
	not reaktsioon(_, Aine).

mida_vaja(Aine, Lahteained) :-
	reaktsioon(Lahteained, Aine), ei_lahe_enam_tagasi(Lahteained).

ei_lahe_enam_tagasi([]) :-
	!.
ei_lahe_enam_tagasi([Aine|Ained]) :-
	not reaktsioon(_, Aine),
	ei_lahe_enam_tagasi(Ained).

mida_vaja(Aine, Vajalikud) :-
	reaktsioon(Lahteained, Aine), vajalikud(Lahteained, Vajalikud).

vajalikud([], []) :-
	!.

vajalikud([Aine|Ained], Vajalikud) :-
	mida_vaja(Aine, Ained1), vajalikud(Ained, Ained2),
	yhenda([Ained1], Ained2, Vajalikud).
	
yhenda([],X,X).

yhenda([X|Y],Z,[X|Y1]) :-
	yhenda(Y,Z,Y1).
