summa([], 0) :- 
	!.

summa([X|Y], S) :-
	summa(Y, S1), S is S1 + X.

min1([], Min, Min) :-
	!.


min1([X|Y], HetkMin, Min) :-
	((X < HetkMin, HetkMin1 is X);(HetkMin1 is HetkMin)),
	min1(Y, HetkMin1, Min).	

min([], 0) :-
	!.

min([X|Y], Min) :-
	min1(Y, X, Min).


tee(tallinn, rakvere,97).
tee(rakvere, kohtla_jrve,73).
tee(kohtla_jrve, narva,50).
tee(tallinn, paide, 97).
tee(paide, tapa, 49).
tee(tapa, rakvere, 28).
tee(rakvere, jogeva, 72).
tee(paide, poltsamaa, 39).
tee(poltsamaa, tartu, 60).
tee(poltsamaa, jogeva, 27).
tee(jogeva, mustvee, 40).
tee(kohtla_jrve, mustvee, 76).
tee(jogeva, mustvee, 40).

paaseb(Linn1, Linn2, TeePikkus) :-
	tee(Linn1, Linn2, TeePikkus).
paaseb(Linn1, Linn2, TeePikkus) :-
	tee(Linn2, Linn1, TeePikkus).

matk(Linn, Linn, Teepikkus, Labitud) :-
	!,
	esita_tee(Teepikkus, Labitud).

matk(Linn1, Linn2, Teepikkus, Labitud) :-
	paaseb(Linn1, Linn, Teepikkus1),
	not(member(Linn, Labitud)),
	Teepikkus2 is Teepikkus + Teepikkus1,
	matk(Linn, Linn2, Teepikkus2, [Linn|Linnad]).

otsi(Linn1, Linn2):-
	matk(Linn1, Linn2, 0, [Linn1]),
	read(_),
	fail.

otsi(_,_).

esita_tee(Teepikkus, Labitud):-
	kirjuta('Tee pikkus on '), kirjuta(Teepikkus), nl, kirjuta('Lbiti linnad: '),
	esita_linnad(Labitud).

esita_linnad([]).

esita_linnad([Linn | Linnad]):-
	esita_linnad(Linnad),
	nl, kirjuta(Linn), nl.
