% predikaat leiatee(AlgRuut, LoppRuut, Summa) leiab AlgRuudu ja LppRuudu vahelise
% tee, mille n. summa on Summa

on_sein(0, _).
on_sein(8, _).
on_sein(_, 0).
on_sein(_, 6).

on_sein(2, 2).
on_sein(4, 2).
on_sein(6, 2).
on_sein(2, 4).
on_sein(4, 4).
on_sein(6, 4).

ruuduvaartus([1,1], 1).
ruuduvaartus([2,1], 1).
ruuduvaartus([3,1], 2).
ruuduvaartus([4,1], 2).
ruuduvaartus([5,1], 2).
ruuduvaartus([6,1], 1).
ruuduvaartus([7,1], 1).

ruuduvaartus([_,2], 3).

ruuduvaartus([1,3], 2).
ruuduvaartus([2,3], 3).
ruuduvaartus([3,3], 4).
ruuduvaartus([4,3], 2).
ruuduvaartus([5,3], 4).
ruuduvaartus([6,3], 2).
ruuduvaartus([7,3], 2).

ruuduvaartus([_,4], 3).

ruuduvaartus([1,5], 1).
ruuduvaartus([2,5], 1).
ruuduvaartus([3,5], 2).
ruuduvaartus([4,5], 2).
ruuduvaartus([5,5], 2).
ruuduvaartus([6,5], 1).
ruuduvaartus([7,5], 1).



saab([X1, Y], [X2, Y]) :-
	X2 is X1 + 1, not on_sein(X2, Y).

saab([X1, Y], [X2, Y]) :-
	X2 is X1 - 1, not on_sein(X2, Y).

saab([X, Y1], [X, Y2]) :-
	Y2 is Y1 + 1, not on_sein(X, Y2).

saab([X, Y1], [X, Y2]) :-
	Y2 is Y1 - 1, not on_sein(X, Y2).


mine(AlgRuut, LoppRuut, LoppRuut, TeeSumma, Labitud) :-
	assert(tee(AlgRuut, LoppRuut, TeeSumma, Labitud)),
	!.

mine(AlgRuut, HetkRuut, LoppRuut, TeeSumma, Labitud) :-
	saab(HetkRuut, UusRuut),
	not is_member(UusRuut, Labitud),
	ruuduvaartus(UusRuut, RuuduVaartus),
	UusSumma is TeeSumma + RuuduVaartus,
	mine(AlgRuut, UusRuut, LoppRuut, UusSumma, [UusRuut|Labitud]).

otsi(AlgRuut, LoppRuut) :-
	ruuduvaartus(AlgRuut, Summa),
	mine(AlgRuut, AlgRuut, LoppRuut, Summa, [AlgRuut]),
	fail.

otsi(_,_).

leiatee(AlgRuut, LoppRuut, Summa) :-
	retractall(tee(_,_,_,_)),
	otsi(AlgRuut, LoppRuut),
	findall([TeeSumma, Labitud], tee(AlgRuut, LoppRuut, TeeSumma, Labitud), LeitudAsjad),
	nl, write('Kogusummaga '), write(Summa), write(' olid jrgmised teed : '), nl,
	valjasta(LeitudAsjad, Summa, []).

valjasta([_|[]], _, _) :-
	!.

valjasta([[Summa, Rada]|Muud], Summa, JubaValjastatud) :-
	not is_member(Rada, JubaValjastatud),
	write(Rada), nl,
	valjasta(Muud, Summa, [Rada|JubaValjastatud]).

valjasta([[_,_]|Muud], Summa, JubaValjastatud) :-
	valjasta(Muud, Summa, JubaValjastatud).
