
% ---------------------------------- Faktoriaal ----------------------------------

fact1(N, FN, N, FN) :- 
	!.

fact1(N1, FN1, N, FN) :-
	N2 is N1 + 1, FN2 is FN1 * N2, fact1(N2, FN2, N, FN).

fact(N) :-
	N >= 0, fact1(0, 1, N, FN), write(N), write('! = '),write(FN),
	nl.

% --------------------------------- /Faktoriaal ----------------------------------





% ---------------------------------- Fibonacci -----------------------------------

fib1(N, N1, N2, N, FN) :-
	FN is N1 + N2, !.

fib1(K, N1, N2, N, FN) :-
	K1 is K + 1, N11 is N1 + N2,
	fib1(K1, N11, N1, N, FN).

fib(N) :- 
	((((N = 1);(N = 2)),FN is N - 1);(N > 2, fib1(2, 1, 0, N, FN))),
	write(N),write('. Fibonacci arv on '),write(FN),nl.


% --------------------------------- /Fibonacci -----------------------------------



% ------------------------------- Vljasta Nimistu -------------------------------

poora_umber(Nimistu, Pooratud) :-
	poora_umber1(Nimistu, [], Pooratud).

poora_umber1([], Pooratud, Pooratud).

poora_umber1([Algus|Lopp], Pooratud, Abi) :-
	poora_umber1(Lopp, [Algus|Pooratud], Abi).

valjasta1([]).

valjasta1([Algus|Lopp]) :-
	write(Algus), nl, valjasta1(Lopp).

valjasta(Nimistu) :-
	poora_umber(Nimistu, PooratudNimistu), valjasta1(PooratudNimistu).


% ------------------------------- Vljasta_Nimistu -------------------------------
