% liida(X,Y) liidab kaks suvalise vrdse pikkusega kahendarvu ja vljastab
% summa




poora_umber(Nimistu, Pooratud) :-
		poora_umber1(Nimistu, [], Pooratud).

poora_umber1([], Pooratud, Pooratud).

poora_umber1([Algus|Lopp], Pooratud, Abi) :-
		poora_umber1(Lopp, [Algus|Pooratud], Abi).


ei_skeem(0,1).
ei_skeem(1,0).

voi_skeem(0, 0, 0).
voi_skeem(0, 1, 1).
voi_skeem(1, 0, 1).
voi_skeem(1, 1, 1).

ja_skeem(0, 0, 0).
ja_skeem(0, 1, 0).
ja_skeem(1, 0, 0).
ja_skeem(1, 1, 1).

voi3(X1,X2,X3,Valjund) :-
		voi_skeem(X1, X2, Valjund1),
		voi_skeem(Valjund1, X3, Valjund).

voi1(Sisse1,Sisse2,Valjund) :-
		ei_X_ja_Y(Sisse1, Sisse2, Valjund11),
		ei_X_ja_Y(Sisse2, Sisse1, Valjund12),
		voi_skeem(Valjund11, Valjund12, Valjund).

ei_X_ja_Y(Sisse1, Sisse2, Valjund) :-
		ei_skeem(Sisse1, Valjund1),
		ja_skeem(Valjund1, Sisse2, Valjund).




liida(X,Y) :- 
		poora_umber(X, PooratudX), poora_umber(Y, PooratudY),
		summa1(PooratudX,PooratudY,0,[],Z), 
		write(Z).


summa1([],[],Ulekanne,Summa,[Ulekanne|Summa]).

summa1([X|XMuu],[Y|YMuu],Ulekanne,Summa,Abi) :-
		summa_ja_meeles(X,Y,Ulekanne,XYSumma,UusUlekanne),
		summa1(XMuu,YMuu,UusUlekanne,[XYSumma|Summa],Abi).		


summa_ja_meeles(X, Y, C, S, C1) :-
		summa(X, Y, C, S),
		meeles(X, Y, C, C1).

meeles(X, Y, C, C1) :-
		ja_skeem(X, Y, XjaY),
		ja_skeem(X, C, XjaC),
		ja_skeem(Y, C, YjaC),
		voi3(XjaY, XjaC, YjaC, C1).

summa(X, Y, C, Summa) :-
		voi1(X, Y, Xvoi1Y),
		voi1(C, Xvoi1Y, Xvoi1Yvoi1C),
		ja_skeem(Y, C, YjaC),
		ja_skeem(X, YjaC, XjaYjaC),
		voi_skeem(Xvoi1Yvoi1C, XjaYjaC, Summa).

summa2(X1,X2,Y1,Y2,S1,S2,S3) :-
		summa_ja_meeles(X2, Y2, 0, S3,C1),
		summa_ja_meeles(X1, Y1, C1, S2, S1).