% toimetab le je 3 misjonri ja 3 kannibali
% hele kaldale ei tohi maha jda rohkem kannibale kui misjonre

alusta :-
	retractall(sibelus(_)),
	mine(seis(3,3,ida), seis(0,0,laane)),
	findall(Asjandus, sibelus(Asjandus), Sibelused),
	remove_dups(Sibelused,KorrastatudSibelused),
	naita_lahendused(KorrastatudSibelused).

mine(Seis, Eesmark) :-
	seisujada(Seis, Eesmark, [Seis], Nimistu),
	poora_umber(Nimistu, Pooratud),
	assert(sibelus(Pooratud)),
	fail.

mine(_,_).

seisujada(Eesmark, Eesmark, Tegemised, Tegemised) :-
	!.

seisujada(Seis, Eesmark, Tegemised, ZZZ) :-
	ylesoit(Seis, Seis1),
	lubatud(Seis1),
	not is_member(Seis1, Tegemised),
	seisujada(Seis1, Eesmark, [Seis1|Tegemised], ZZZ).

ylesoit(seis(K1,M,ida), seis(K2,M,laane)) :-
	((K2 is K1 - 2);(K2 is K1 - 1)), not(K2 < 0).

ylesoit(seis(K1,M,laane), seis(K2,M,ida)) :-
	((K2 is K1 + 2);(K2 is K1 + 1)), not(K2 > 3).

ylesoit(seis(K,M1,ida), seis(K,M2,laane)) :-
	((M2 is M1 - 2);(M2 is M1 - 1)), not(M2 < 0).

ylesoit(seis(K,M1,laane), seis(K,M2,ida)) :-
	((M2 is M1 + 2);(M2 is M1 + 1)), not(M2 > 3).

ylesoit(seis(K1,M1,ida), seis(K2,M2,laane)) :-
	M2 is M1 - 1, not(M2 < 0), K2 is K1 - 1, not(K2 < 0).

ylesoit(seis(K1,M1,laane), seis(K2,M2,ida)) :-
	M2 is M1 + 1, not(M2 > 3), K2 is K1 + 1, not(K2 > 3).

lubatud(seis(_,3,_)).

lubatud(seis(_,0,_)).

lubatud(seis(S,S,_)).

poora_umber(Nimistu, Pooratud) :-
		poora_umber1(Nimistu, [], Pooratud).

poora_umber1([], Pooratud, Pooratud).

poora_umber1([Algus|Lopp], Pooratud, Abi) :-
		poora_umber1(Lopp, [Algus|Pooratud], Abi).

naita_lahendused([]) :-
	!.

naita_lahendused([Alg|Lopp]) :-
	nl, nl, write('Lahendus :'),
	nl, naita_lahendus(Alg),naita_lahendused(Lopp).

naita_lahendus([Alg,Lopp|[]]) :-
	!,
	naita_pilti(Alg,Lopp).

naita_lahendus([Alg,Lopp|T]) :-
	!,
	naita_pilti(Alg,Lopp),naita_lahendus([Lopp|T]).

naita_pilti(seis(K1,M,Paat1),seis(K2,M,Paat2)) :-
	((K2 > K1, Vahe is K2 - K1);(K1 > K2, Vahe is K1 - K2)),
	write(Vahe),write(' kannibal'),((Vahe = 2,write('i'));true),write(' sidab '),
	write(Paat1),write('kaldalt '),write(Paat2),write('kaldale.'),nl,!.

naita_pilti(seis(K,M1,Paat1),seis(K,M2,Paat2)) :-
	((M2 > M1, Vahe is M2 - M1);(M1 > M2, Vahe is M1 - M2)),
	write(Vahe),write(' misjonr'),((Vahe = 2,write('i'));true),write(' sidab '),
	write(Paat1),write('kaldalt '),write(Paat2),write('kaldale.'),nl,!.

naita_pilti(seis(_,_,Paat1),seis(_,_,Paat2)) :-
	write('1 kannibal ja 1 misjonr sidavad '),
	write(Paat1),write('kaldalt '),write(Paat2),write('kaldale.'),nl,!.
