% ----------------------------------------------------------------------------------------------
% Loogiline programmeerimine
% Kontrollt 07.12.1999
% Erki Suurjaak
% LAP52
% 970772
% ----------------------------------------------------------------------------------------------






% ----------------------------------------- lesanne #3 ----------------------------------------
%
% lesanne #3 - nimistu tasandamine
% Niielda kasutajaliidesega predikaat on flatten(Nimistu)
% Ssteemselt kasutatav predikaat on flatten1(Nimistu, Flattened)

flatten(Algne) :-
	flatten1(Algne, Flattened), nl,
	write('Algne nimistu      : '), write(Algne),nl,
	write('Tasandatud nimistu : '), write(Flattened),nl.

flatten1([], []).                                      % Kui nimistu thi, on ka flattened thi

flatten1([[]|Muud], Flattened) :-                      % Kui algne nimistu thi, siis see 
	!, flatten1(Muud, Flattened).                  % visatakse krvale

flatten1([[SiseNimistuAlg|SiseNimistuMuud]|Muud], [Alg|Flattened]) :-
                                                       % Kui alguses on nimistu, siis tuleb
                                                       % kigepealt see tdelda,
                                                       % siis lejnud
	flatten1([SiseNimistuAlg|SiseNimistuMuud], [Alg|Flattened1]),
	!, flatten1([Flattened1|Muud], Flattened).

flatten1([Alg|Muud], [Alg|Flattened]) :-               % Kui siiani juti, siis thendab, et
  flatten1(Muud, Flattened).                           % nimistu esimene element pole nimistu

% ---------------------------------------- /lesanne #3 ----------------------------------------






% ----------------------------------------- lesanne #6 ----------------------------------------
%
% lesanne #6 - krptogrammi SEND+MORE=MONEY lahendamine
% Programm leiab kikvimalikud lahendid
% Predikaat on kryptogramm

assign_num(0).
assign_num(1).
assign_num(2).
assign_num(3).
assign_num(4).
assign_num(5).
assign_num(6).
assign_num(7).
assign_num(8).
assign_num(9).

kryptogramm :-
	assign_num(E), assign_num(D), not(D = E),
	assign_num(Y), Y is (D + E) mod 10,
	assign_num(N), not(N = D), not(N = E), not(N = Y),
	assign_num(R), not(R = N), not(R = D), not(R = E), not(R = Y),
	E is (((N + R)*10 + (D + E)) divu 10) mod 10,
	assign_num(O), not(O = R), not(O = N), not(O = D), not(O = E), not(O = Y),
	N is (((E + O)*100 + (N + R)*10 + (D + E)) divu 100) mod 10,
	assign_num(S), S > 0, not(S = O), not(S = R), not(S = N), not(S = D), not(S = E),
	not(S = Y),
	assign_num(M), M > 0, not(M = S), not(M = O), not(M = R), not(M = N), not(M = D), 
	not(M = E), not(M = Y),
	S1 is (((S + M)*1000 + (E + O)*100 + (N + R)*10 + (D + E)) divu 1000),
	S1 is M*10 + O,
	nl,
	write('   '), write(S), write(' '), write(E), write(' '), write(N), write(' '), write(D),
	nl,
	write(' + '), write(M), write(' '), write(O), write(' '), write(R), write(' '), write(E),
	nl, write('-----------'), nl,
	write(' '), write(M), write(' '), write(O), write(' '), write(N), write(' '), write(E), 
	write(' '), write(Y), nl, nl, fail.

% ----------------------------------------- /lesanne #6 ---------------------------------------
