% ----------------------------------------------------------------
% Kontrollt 26.10.1999
% I variant
% Erki Suurjaak
% LAP52
% 970772
% ----------------------------------------------------------------






% ----------------------------------------------------------------
% Esimene lesanne

poeg(okeanos, uranos). 
poeg(koios, uranos). 
poeg(kronos, uranos). 
tytar(demeter, kronos). 
poeg(atlas, iapetos). 
poeg(iapetos, gaia). 

meessoost(uranos).

meessoost(Isik) :- 
	poeg(Isik,_).

laps(Laps,Vanem) :-
	poeg(Laps,Vanem).
laps(Laps,Vanem) :-
	tytar(Laps,Vanem).

esivanem(Isik,Esivanem) :-
	laps(Isik,Esivanem).
esivanem(Isik,Esivanem) :-
	laps(Isik,Vahelyli),
	esivanem(Vahelyli,Esivanem).

% /Esimene lesanne
% ----------------------------------------------------------------






% ----------------------------------------------------------------
% Teine lesanne. Lahenduspredikaat on "kordseid".

kordseid(Nimistu, Kordsed) :-
	leiakordsed(Nimistu,Nimistu,[],Mitmekordsed),
	remove_dups(Mitmekordsed, Kordsed).

leiakordsed([],_,Kordsed,Kordsed) :-
	!.

leiakordsed([Esimene|Muud],TaisList,AlgsedKordsed,UuedKordsed) :-
	teeloendus(Esimene,TaisList,0,Mitu),
	leiakordsed(Muud,TaisList, [[Esimene,Mitu]|AlgsedKordsed], UuedKordsed).

teeloendus(_,[],Number,Number) :-
	!.

teeloendus(Element,[Element|Muud],VanaNumber,YldseKokku) :-
	!, UusNumber is VanaNumber + 1,
	teeloendus(Element,Muud,UusNumber,YldseKokku).

teeloendus(Element,[_|Muud],VanaNumber,YldseKokku) :-
	teeloendus(Element,Muud,VanaNumber,YldseKokku).

% /Teine lesanne
% ----------------------------------------------------------------






% ----------------------------------------------------------------
% Kolmas lesanne. Lahenduspredikaat on "minlinnu".

tee(paide, tapa, 49). 
tee(jogeva, mustvee, 40). 
tee(tapa, rakvere, 28). 
tee(rakvere, jogeva, 72). 
tee(tallinn, rakvere,97). 
tee(rakvere, kohtla_jrve,73). 
tee(kohtla_jrve, narva,50). 
tee(tallinn, paide, 97). 
tee(tallinn,rakvere,96). 
tee(paide, poltsamaa, 39). 
tee(poltsamaa, tartu, 60). 
tee(poltsamaa, jogeva, 27). 
tee(jogeva, mustvee, 40). 
tee(kohtla_jrve, mustvee, 76). 


saab(Linn1, Linn2, TeePikkus) :-
	tee(Linn1, Linn2, TeePikkus).

saab(Linn1, Linn2, TeePikkus) :-
	tee(Linn2, Linn1, TeePikkus).

matk(Linn1, Linn, Linn, Teepikkus, Lbitud, LbitudLinnu) :-
	!,
	assert(reis(Linn1, Linn, Teepikkus, Lbitud, LbitudLinnu)).

matk(AlgusLinn, Linn1, Linn2, Teepikkus, Lbitud, LbitudLinnu) :-
	saab(Linn1, Linn, Teepikkus1),
	not is_member(Linn, Lbitud),
	Teepikkus2 is Teepikkus + Teepikkus1,
	LbitudLinnu2 is LbitudLinnu + 1,
	matk(AlgusLinn, Linn, Linn2, Teepikkus2, [Linn|Lbitud], LbitudLinnu2).

otsi(Linn1, Linn2) :-
	matk(Linn1, Linn1, Linn2, 0, [Linn1], 1),
	fail.

otsi(_,_).

minlinnu(Linn1, Linn2) :-
	retractall(reis(_,_,_,_,_)),
	write('See vib veidi aega vtta...'), nl,
	otsi(Linn1, Linn2),
	findall([Teepikkus, Labitud, Linnu], reis(Linn1, Linn2, Teepikkus, Labitud, Linnu), Teepikkused),
	min(Teepikkused, LyhimTee, LyhimRada, LyhimLinnu), 
	write('Lbitud linnad : '), write(LyhimRada), nl,
	write('Teepikkus : '), write(LyhimTee), nl.


min([[X, Y, Z]|[]], X, Y, Z) :-
	!.

min([[Esimene, Rada, Linnu]|Muud], Esimene, Rada, Linnu) :-
	min(Muud, _, _, Min1),
	Linnu < Min1,
	!.

min([[_,_,_]|Muud], MinTee, MinRada, MinLinnu) :-
	min(Muud, MinTee, MinRada, MinLinnu).



% /Kolmas lesanne
% ----------------------------------------------------------------
