% leiab lhima tee kahe linna vahel


tee(tallinn, rakvere,97).
tee(rakvere, kohtla_jarve,73).
tee(kohtla_jarve, narva,50).
tee(tallinn, paide, 97).
tee(paide, tapa, 49).
tee(tapa, rakvere, 28).
tee(rakvere, jogeva, 72).
tee(paide, poltsamaa, 39).
tee(poltsamaa, tartu, 60).
tee(poltsamaa, jogeva, 27).
tee(jogeva, mustvee, 40).
tee(kohtla_jarve, mustvee, 76).
tee(jogeva, mustvee, 40).

saab(Linn1, Linn2, TeePikkus) :-
	tee(Linn1, Linn2, TeePikkus).

saab(Linn1, Linn2, TeePikkus) :-
	tee(Linn2, Linn1, TeePikkus).

matk(Linn1, Linn, Linn, Teepikkus, Labitud) :-
	!,
	assert(reis(Linn1, Linn, Teepikkus, Labitud)).
%	write(Linn1),write(Linn2),write(Teepikkus),nl.
%	esita_tee(Teepikkus, Labitud).

matk(AlgusLinn, Linn1, Linn2, Teepikkus, Lbitud) :-
	saab(Linn1, Linn, Teepikkus1),
	not is_member(Linn, Lbitud),
	Teepikkus2 is Teepikkus + Teepikkus1,
	matk(AlgusLinn, Linn, Linn2, Teepikkus2, [Linn|Lbitud]).


otsi(Linn1, Linn2) :-
	matk(Linn1, Linn1, Linn2, 0, [Linn1]),
	fail.

otsi(_,_).

esita_tee(Teepikkus, Lbitud):-
	write('Tee pikkus on '),
	write(Teepikkus),
	nl,
	write('Lbiti linnad: '), nl,
	esita_linnad(Lbitud).

esita_linnad([]).

esita_linnad([Linn | Linnad]) :-
	esita_linnad(Linnad),
	write(Linn),
	nl.


lyhim(Linn1, Linn2) :-
	retractall(reis(_,_,_,_)),
	otsi(Linn1, Linn2),
	findall([Teepikkus, Labitud], reis(Linn1, Linn2, Teepikkus, Labitud), Teepikkused),
	min(Teepikkused, LyhimTee, LyhimRada), 
	write(LyhimTee), nl, write(LyhimRada).


min1([X, Y], HetkeTee, HetkeRada, UusT, UusR) :-
	((X < HetkeTee, UusT is X, UusR is Y);
	(UusT is HetkeTee, UusR is HetkeRada)),
	!.

min1([[EsimTee, EsimRada]|Muud], HetkeTee, HetkeRada, UusTee, UusRada) :-
	((EsimTee < HetkeTee, Tee1 is EsimTee, Tee2 is EsimRada);
	(Tee1 is HetkeTee, Tee2 is HetkeRada)),
	min1(Muud, Tee1, Tee2, UusTee, UusRada).


min([[X, Y]|[]], X, Y) :-
	!.

min([[Esimene, Rada]|Muud], Esimene, Rada) :-
	min(Muud, Min1, _),
	Esimene < Min1,
	!.

min([[_,_]|Muud], MinTee, MinRada) :-
	min(Muud, MinTee, MinRada).

