mang :-
	write('Edaspidi mrgi ruudud numbritega:'),
	nl, nl, joonista_algseis, nl,
	write('Kumb algab (a/i)?'),
	read(Vastus),
	(Vastus = a, !, arvuti_kaik([],[],[1,2,3,4,5,6,7,8,9]);
	(Vastus = i, inimese_kaik([],[],[1,2,3,4,5,6,7,8,9]))).


joonista_algseis :-
	asserta(mark(N,_,_,N)),
	joonista_seis([],[]),
	retract(mark(N,_,_,N)).

joonista_seis(Arvuti,Inimene) :-
	sirge(5,' '),
	joonista_rida(1,Arvuti,Inimene),
	nl,
	sirge(5,' '),
	sirge(10,'-'),
	nl,
	sirge(5,' '),
	joonista_rida(2,Arvuti,Inimene),
	nl,
	sirge(5,' '),
	sirge(10,'-'),
	nl,
	sirge(5,' '),
	joonista_rida(3,Arvuti,Inimene),
	nl.

mark(N,Arvuti,Inimene,'X') :-
	member(N,Arvuti), !.

mark(N,Arvuti,Inimene,'O') :-
	member(N,Inimene), !.

mark(_,_,_,' ').

joonista_rida(N,Arvuti,Inimene) :-
	N1 is 3 * (N - 1) + 1,
	mark(N1,Arvuti,Inimene,Mark1),
	write(Mark1),
	write(' | '),
	N2 is N1 + 1,
	mark(N2,Arvuti,Inimene,Mark2),
	write(Mark2),
	write(' | '),
	N3 is N2 + 1,
	mark(N3,Arvuti,Inimene,Mark3),
	write(Mark3).


sirge(0,_) :-
	!.

sirge(Pikkus,Mark) :-
	write(Mark),
	Pikkus1 is Pikkus - 1,
	sirge(Pikkus1,Mark).

inimese_kaik(Arvuti,Inimene,Vabad) :-
	kontrolli_viik(Arvuti,Inimene,Vabad).

inimese_kaik(Arvuti,Inimene,Vabad) :-
	write('Sinu kik, kirjuta selle ruudu number, kuhu tahad mrgi!'),
	nl, nl,
	read(Kaik),
	kontrolli_kaik(Arvuti, Inimene, Vabad, Kaik).

kontrolli_kaik(Arvuti, Inimene, Vabad, Kaik)	:-
	member(Kaik,Vabad),
	!,
	vahe(Kaik,Vabad,Vahe),
	arvuti_kaik(Arvuti,[Kaik|Inimene],Vahe).

kontrolli_kaik(Arvuti, Inimene, Vabad, _)	:- 
	write('See kik ei ole lubatud!'),
	nl,
	inimese_kaik(Arvuti,Inimene,Vabad).

arvuti_kaik(Arvuti,Inimene,Vabad) :-
	voidab(Inimene),
	write('nnitlen, vitsid!'),
	nl.

arvuti_kaik(Arvuti,Inimene,Vabad) :-
	kontrolli_viik(Arvuti,Inimene,Vabad).

arvuti_kaik(Arvuti,Inimene,Vabad) :-
	kaik(Arvuti,Inimene,Vabad,Kaik),
	write('Rist ruudule '),
	write(Kaik),
	nl,nl,
	joonista_seis([Kaik|Arvuti],Inimene),
	nl,
	kontrolli_voit(Arvuti, Inimene, Vabad, Kaik).

kontrolli_voit(Arvuti, Inimene, Vabad, Kaik) :-
	voidab([Kaik|Arvuti]),
	!,
	write('Vitsin!'),
	nl.

kontrolli_voit(Arvuti, Inimene, Vabad, Kaik) :-
	vahe(Kaik,Vabad,Vahe),
	inimese_kaik([Kaik|Arvuti],Inimene,Vahe).

kontrolli_viik(Arvuti,Inimene,Vabad) :-
	append(Arvuti,Vabad,Ruudud1),
	not voidab(Ruudud1),
	append(Inimene,Vabad,Ruudud2),
	not voidab(Ruudud2),
	write('See mng on viik'),
	nl.

voidab(Ruudud) :-
	sirgeid(Ruudud,Arv),
	Arv > 0.

sirgeid(Ruudud,Arv) :-
	findall(S,(sirge(S),alamnimistu(S,Ruudud)),Sirged),
	length(Sirged,Arv).

alamnimistu([],Ruudud2) :-
	!.

alamnimistu([X|Y],Z):-
	member(X,Z),
	alamnimistu(Y,Z).

kaik(Arvuti,Inimene,Vabad,Ruut) :-
	member(Ruut,Vabad),
	voidab([Ruut|Arvuti]).

kaik(Arvuti,Inimene,Vabad,Ruut) :-
	member(Ruut,Vabad),
	voidab([Ruut|Inimene]).

kaik(Arvuti,Inimene,Vabad,Ruut) :-
	parim(Arvuti,Inimene,Vabad,Ruut).

parim(Arvuti,Inimene,Vabad,Ruut) :-
	findall([R,Punktid],
	(member(R,Vabad), ruudu_Punktid(Arvuti,Inimene,Vabad,R,Punktid)),PunktiRuudud),
	korgeim(Ruut,Punktid,PunktiRuudud).

ruudu_Punktid(Arvuti,Inimene,Vabad,Ruut,Punktid) :-
	vahe(Ruut,Vabad,Vahe),
	seis([Ruut|Arvuti],Inimene,Vahe,Punktid).

korgeim(Ruut,Punktid,[[Ruut,Punktid]]) :-
	!.

korgeim(Ruut,Punktid,[[R1,P1]|Ruudud]) :-
	korgeim(R2,P2,Ruudud),
	leia_max(R1, P1, R2, P2, Ruut, Punktid).

leia_max(R1, P1, R2, P2, R1, P1) :-
	P1 > P2,
	!.

leia_max(R1, P1, R2, P2, R2, P2).

seis(Arvuti,Inimene,Vabad,Punktid) :-
	append(Arvuti,Vabad,Arvutivoimalikud),
	sirgeid(Arvutivoimalikud,Arvutisirged),
	append(Inimene,Vabad,Inimesevoimalikud),
	sirgeid(Inimesevoimalikud,Inimesesirged),
	Punktid is Arvutisirged - Inimesesirged.

vahe(Ruut,[Ruut|Muud],Muud1) :-
	!,
	vahe(Ruut, Muud, Muud1).

vahe(Ruut,[Ruut1|Muud], [Ruut1|Vahe]) :-
	not(Ruut=Ruut1),
	vahe(Ruut, Muud, Vahe).

vahe(_,[],[]).

sirge([1,2,3]).
sirge([4,5,6]).
sirge([7,8,9]).
sirge([1,4,7]).
sirge([2,5,8]).
sirge([3,6,9]).
sirge([1,5,9]).
sirge([3,5,7]).

length(Nimistu,Length) :-
	length_1(Nimistu,0,Length).

length_1([],Length,Length).

length_1([Essa|Muud],Length,ZZZ) :-
	Length1 is Length + 1,
	length_1(Muud,Length1,ZZZ).

append([],N,N).

append([EssaN1|N1],Y,[EssaN1|N]) :-
	append(N1,Y,N).

member(A, [A|_]).
member(A, [_|Z]) :- member(A, Z).
